unit Principal;

interface

uses
  SysUtils, Types, Classes, Variants, Windows, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus,
  ExtCtrls, ComCtrls,
  QGame, XPMan;

type
  TfrmPrincipal = class(TForm)
    mmPrincipal: TMainMenu;
    Jogo1: TMenuItem;
    mnNovo: TMenuItem;
    Sair1: TMenuItem;
    Direcao1: TMenuItem;
    opo1: TMenuItem;
    Direita1: TMenuItem;
    Esquerda1: TMenuItem;
    Baixo1: TMenuItem;
    Ajuda1: TMenuItem;
    Ajuda2: TMenuItem;
    N1: TMenuItem;
    Sobre1: TMenuItem;
    N2: TMenuItem;
    ReiniciarJogo1: TMenuItem;
    sbPrincipal: TStatusBar;
    XPManifest1: TXPManifest;
    procedure mnNovoClick(Sender: TObject);
    procedure opo1Click(Sender: TObject);
    procedure Direita1Click(Sender: TObject);
    procedure Esquerda1Click(Sender: TObject);
    procedure Baixo1Click(Sender: TObject);
    procedure Sobre1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ReiniciarJogo1Click(Sender: TObject);
  private
    { Private declarations }
    Jogo: TExGameFile;
    procedure NovoJogo(Sender: TObject);
    procedure Vitoria(Sender: TObject);
  public
    { Public declarations }
  end;

var
  frmPrincipal: TfrmPrincipal;

implementation

{$R *.dfm}

procedure TfrmPrincipal.mnNovoClick(Sender: TObject);
begin
  Jogo.New;
end;

procedure TfrmPrincipal.opo1Click(Sender: TObject);
begin
  Jogo.Selection.GoTop;
end;

procedure TfrmPrincipal.Direita1Click(Sender: TObject);
begin
  Jogo.Selection.GoRight;
end;

procedure TfrmPrincipal.Esquerda1Click(Sender: TObject);
begin
  Jogo.Selection.GoLeft;
end;

procedure TfrmPrincipal.Baixo1Click(Sender: TObject);
begin
  Jogo.Selection.GoDown;
end;

procedure TfrmPrincipal.Sobre1Click(Sender: TObject);
begin
  Jogo.About;
end;

procedure TfrmPrincipal.Vitoria(Sender: TObject);
begin
  Jogo.New;
end;

procedure TfrmPrincipal.NovoJogo(Sender: TObject);
begin
  Self.ClientHeight := Height + sbPrincipal.Height;
  Self.ClientWidth  := Width;
  Jogo.Visible := True;
  Jogo.SetFocus;
  sbPrincipal.Panels[0].Text := '';
end;

procedure TfrmPrincipal.FormCreate(Sender: TObject);
begin
  Jogo := TExGameFile.Create(Self);
  with  Jogo do begin
        OnNewGame := NovoJogo;
        OnGameWin := Vitoria;
        Visible := False;
  end;
end;

procedure TfrmPrincipal.ReiniciarJogo1Click(Sender: TObject);
begin
if  MessageDlg('Deseja realmente reiniciar a partida?', mtConfirmation, [mbYes,mbNo,mbCancel], 0) = mrYes then
    Jogo.Reload;
end;

end.